<?php

  class pz_data_users extends pz_data
  {

    var $_user;

    # ----------------------------------------------------------------------------------------
    #                                                                                    users
    #

    function users($start = 0, $alpha = null)
    { $sgbd = $this->sgbd();
      $env = $this->env();
      $users = array("list" => array(), "total" => 0);
      if($rst = $sgbd->open_data("users"))
      { while($v_rst = $sgbd->fetch_data($rst))
        { if(isset($v_rst))
          { if(!isset($alpha) || (isset($v_rst["login"]) && substr($v_rst["login"], 0, 1) == $alpha))
            { $users["total"]++;
              if(!$env->config("max_list") || ($users["total"] > $start && $users["total"] < ($start + $env->config("max_list"))))
              { $users["list"][$v_rst["id"]] = $v_rst;
              }
            }
          }
          else
          { $users = false;
            break;
          }
        }
        $sgbd->close_data($rst);
      }
      else $users = false;
      return $users;
    }

    function user($login)
    { $sgbd = $this->sgbd();
      $user = array();
      if($rst = $sgbd->open_data("users"))
      { while($v_rst = $sgbd->fetch_data($rst))
        { if(isset($v_rst))
          { if(isset($v_rst["login"]) && $v_rst["login"] == $login)
            { $user = $v_rst;
              break;
            }
          }
          else $user = false;
        }
        $sgbd->close_data($rst);
      }
      else $user = false;
      return $user;
    }

    function user_exists($login)
    { $sgbd = $this->sgbd();
      $EXISTS = 0;
      if($rst = $sgbd->open_data("users"))
      { while($v_rst = $sgbd->fetch_data($rst))
        { if(isset($v_rst))
          { if(isset($v_rst["login"]) && $v_rst["login"] == $login)
            { $EXISTS++;
            }
          }
          else
          { $EXISTS = false;
            break;
          }
        }
        $sgbd->close_data($rst);
      }
      else $EXISTS = false;
      return $EXISTS;
    }

    function add_user($login, $password, $email, $status)
    { $sgbd = $this->sgbd();
      return $sgbd->add_data
      ( "users",
        array
        ( "login" => $login,
          "password" => $password,
          "email" => $email,
          "status" => $status
        )
      );
    }

    function set_user($id, $login, $password, $email, $status)
    { $sgbd = $this->sgbd();
      return $sgbd->set_data
      ( "users",
        $id,
        array
        ( "login" => $login,
          "password" => $password,
          "email" => $email,
          "status" => $status
        )
      );
    }

    function del_user($login)
    { if(($user = $this->user($login)) !== false)
      { $sgbd = $this->sgbd();
        return $sgbd->del_data("users", $user["id"]);
      }
      return false;
    }

    # ----------------------------------------------------------------------------------------
    #                                                                                   status
    #

    function status()
    { $sgbd = $this->sgbd();
      $status = array();
      if($rst = $sgbd->open_data("user_status"))
      { while($v_rst = $sgbd->fetch_data($rst))
        { if(isset($v_rst))
          { $status[$v_rst["id"]] = $v_rst;
          }
          else
          { $status = false;
            break;
          }
        }
        $sgbd->close_data($rst);
      }
      else $status = false;
      return $status;
    }

    function get_user_status()
    { $user = $this->get_session_user();
      if($user && isset($user["status"])) return $user["status"];
      return 0;
    }

    function get_action_status($mod, $controller = "index", $action = "index")
    { $sgbd = $this->sgbd();
      $status = array();
      if($rst = $sgbd->open_data("action_status"))
      { while($v_rst = $sgbd->fetch_data($rst))
        { if(isset($v_rst) && isset($v_rst["action"]) && isset($v_rst["id_status"]))
          { if
            (    $v_rst["action"] == $mod
              || $v_rst["action"] == $mod."/".$controller
              || $v_rst["action"] == $mod."/".$controller."/".$action
            )
            { if(!isset($status[$v_rst["action"]])) $status[$v_rst["action"]] = array();
              $status[$v_rst["action"]][$v_rst["id_status"]] = true;
            }
          }
          else $status = false;
        }
        $sgbd->close_data($rst);
      }
      else $status = false;
      return $status;
    }

    function creation_default_status()
    { $sgbd = $this->sgbd();
      $default_status = 0;
      if($rst = $sgbd->open_data("user_status"))
      { while($v_rst = $sgbd->fetch_data($rst))
        { if(isset($v_rst))
          { if(isset($v_rst["creation_default"]) && $v_rst["creation_default"] == 1)
            { $default_status = $v_rst["id"];
              break;
            }
          }
          else
          { $default_status = false;
            break;
          }
        }
        $sgbd->close_data($rst);
      }
      else $default_status = false;
      return $default_status;
    }

    # ----------------------------------------------------------------------------------------
    #                                                                             log in / out
    #

    function login($login, $password)
    { if(($user = $this->user($login)) !== false)
      { if($this->password_ok($user, $password))
        { if(!$this->set_session($user)) $user = false;
        }
        else
        { $this->clear_session();
          $user = array();
        }
      }
      return $user;
    }

    function logout()
    { return $this->clear_session();
    }

    function user_ok($user)
    { return
      strcmp(md5($user["password"].$_SESSION["id"]), $_SESSION["pass"]) == 0
      && $_SESSION["ip"] == $_SERVER["REMOTE_ADDR"];
    }

    function password_ok($user, $password)
    { return
      strcmp(md5($user["password"].$_SESSION["id"]), $password) == 0
      && $_SESSION["ip"] == $_SERVER["REMOTE_ADDR"];
    }

    # ----------------------------------------------------------------------------------------
    #                                                                                  session
    #

    function load_session()
    { session_start();
      if(!isset($_SESSION["id"])) $this->clear_session();
      if
      ( $user =
        ( isset($_COOKIE["user"]) || isset($_SESSION["user"]) ?
            $this->user(isset($_COOKIE["user"]) ? $_COOKIE["user"] : $_SESSION["user"])
          : array()
        )
      )
      { if(isset($_COOKIE["user"])) $this->set_session($user);
        if(!$this->user_ok($user))
        { $this->clear_session();
          $user = array();
        }
      }
      $this->_user = $user;
      return $user;
    }

    function set_session($user)
    { $_SESSION["user"] = $user["login"];
      $_SESSION["pass"] = md5($user["password"].$_SESSION["id"]);
      $env = $this->env();
      return setcookie("user", $user["login"], time() + (60 * 60 * 24 * 7), $env->path("web"));
    }

    function clear_session()
    { unset($_SESSION["user"]);
      unset($_SESSION["pass"]);
      $_SESSION["ip"] = $_SERVER["REMOTE_ADDR"];
      $_SESSION["id"] = md5(rand());
      return setcookie("user", "", time() + (60 * 60 * 24 * 7));
    }

    function get_session_user() { return $this->_user; }

    # ----------------------------------------------------------------------------------------
    #                                                                                  uploads
    #

    function check_user_uploads_dir($user = null)
    { $env = $this->env();
      $user_dir = $env->path("content")."uploads/".(isset($user) ? $user : $this->_user["id"]);
      if(!file_exists($user_dir)) @mkdir($user_dir);
      return file_exists($user_dir);
    }

  }

?>