<?php

  class pz_sources_morceau extends pz_mod
  {
    var $groupes;
    var $groupe;
    var $albums;
    var $album;
    var $morceau;
    var $status;
    var $album_status_id;
    var $morceau_status_id;
    var $piste_status_id;
    var $licences;

    function validate(&$env)
    { $data = $env->data();
      if(($this->status = $data->source_status()) === false)
      { return "Impossible de lire la liste des status de source";
      }
      foreach($this->status as $id_source_status => $source_status)
      { if($source_status["nom"] == "album") $this->album_status_id = $id_source_status;
        if($source_status["nom"] == "morceau") $this->morceau_status_id = $id_source_status;
        if($source_status["nom"] == "piste") $this->piste_status_id = $id_source_status;
        if(isset($this->album_status_id) && isset($this->morceau_status_id) && isset($this->piste_status_id)) break;
      }
      if(!isset($this->album_status_id)) return "Type de source inconnu: album";
      if(!isset($this->morceau_status_id)) return "Type de source inconnu: morceau";
      if(!isset($this->piste_status_id)) return "Type de source inconnu: piste";
      if(($this->licences = $data->licences()) === false)
      { return "Impossible de lire la liste des status des licences";
      }
      if(isset($_GET[$env->param("morceau")]) && $_GET[$env->param("morceau")])
      { if(($this->morceau = $data->source($_GET[$env->param("morceau")])) === false)
        { return "Impossible de lire les informations du morceau";
        }
        if(($this->groupe = $data->groupe($this->morceau["id_groupe"])) === false)
        { return "Impossible de lire les informations du groupe";
        }
        $select = array("status" => $this->album_status_id);
        $select["id_groupe"] = $this->groupe["id"];
        if(($this->albums = $data->sources($select)) === false) return "impossible de lire la liste des albums";
        $select = array("status" => $this->piste_status_id);
        $select["id_composition"] = $this->morceau["id"];
        $select["start"] = isset($_GET[$env->param("start")]) ? $_GET[$env->param("start")] : 0;
        if(($this->pistes = $data->sources($select)) === false) return "impossible de lire la liste des pistes";
      }
      else
      { if(isset($_GET[$env->param("groupe")]) && $_GET[$env->param("groupe")])
        { if(($this->groupe = $data->groupe($_GET[$env->param("groupe")])) === false)
          { return "Impossible de lire les informations du groupe";
          }
        }
      }
      if(isset($_GET[$env->param("album")]) && $_GET[$env->param("album")])
      { if(($this->album = $data->source($_GET[$env->param("album")])) !== false)
        { if(($this->groupe = $data->groupe($this->album["id_groupe"])) === false)
          { return "Impossible de lire les informations du groupe";
          }
        }
        else return "Impossible de lire les informations de l'album";
      }
      if(!isset($_GET[$env->param("morceau")]))
      { $select = array("status" => $this->album_status_id);
        if(isset($this->groupe)) $select["id_groupe"] = $this->groupe["id"];
        if(($this->albums = $data->sources($select)) === false) return "impossible de lire la liste des albums";
      }
      return true;
    }

    function index(&$env)
    { $data = $env->data();
      if(isset($this->licences) && $this->licences !== false)
      { if(($this->groupes = $data->groupes()) !== false)
        { $env->set_out("groupes", $this->groupes);
          if(isset($this->albums) && $this->albums !== false)
          { $env->set_out("albums", $this->albums);
            $select = array();
            $select["status"] = $this->morceau_status_id;
            $select["order_by"] = "ordre";
            if(isset($_GET[$env->param("groupe")]) && $_GET[$env->param("groupe")]) $select["id_groupe"] = $_GET[$env->param("groupe")];
            if(isset($_GET[$env->param("album")]) && $_GET[$env->param("album")]) $select["id_composition"] = $_GET[$env->param("album")];
            $select["start"] = isset($_GET[$env->param("start")]) && $_GET[$env->param("start")] ? $_GET[$env->param("start")] : 0;
            if(($morceaux = $data->sources($select)) !== false)
            { $env->set_out("morceaux", $morceaux);
              if($this->groupe)
              { $env->set_out("groupe", $this->groupe);
                if($this->album)
                { $env->set_out("album", $this->album);
                }
              }
            }
            else $env->erreur("Impossible de lire la liste des morceaux");
          }
          else $env->erreur("Impossible de lire la liste des albums");
        }
        else $env->erreur("Impossible de lire la liste des groupes");
      }
    }


    function view(&$env)
    { $data = $env->data();
      if(isset($this->licences) && $this->licences !== false)
      { $env->set_out("licences", $this->licences);
        if($this->morceau)
        { $env->set_out("morceau", $this->morceau);
          if($this->groupe)
          { $this->groupe["image"] =
            ( $this->groupe["image"] ?
                $env->path("content")."uploads/".$this->groupe["id_user"]."/".$this->groupe["image"]
              : ""
            );
            $env->set_out("groupe", $this->groupe);
            if($this->albums)
            { $env->set_out("albums", $this->albums);
              if($this->album)
              { $env->set_out("album", $this->album);
              }
              if($this->pistes)
              { $env->set_out("pistes", $this->pistes);
              }
            }
          }
        }
      }
    }

  }

?>